import { ListDirectoryBucketsCommand, } from "../commands/ListDirectoryBucketsCommand";
import { S3Client } from "../S3Client";
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new ListDirectoryBucketsCommand(input), ...args);
};
export async function* paginateListDirectoryBuckets(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.ContinuationToken = token;
        input["MaxDirectoryBuckets"] = config.pageSize;
        if (config.client instanceof S3Client) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected S3 | S3Client");
        }
        yield page;
        const prevToken = token;
        token = page.ContinuationToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
